annotate vamp-server/test.sh @ 150:bf8e3e7dd7de

Move some things around, and add overall test script
author Chris Cannam <cannam@all-day-breakfast.com>
date Fri, 20 Jan 2017 17:45:54 +0000
parents
children 0876b5e67afe
rev   line source
cannam@150 1 #!/bin/bash
cannam@150 2
cannam@150 3 set -eu
cannam@150 4
cannam@150 5 piperdir=../piper
cannam@150 6 vampsdkdir=../vamp-plugin-sdk
cannam@150 7 schemadir="$piperdir"/json/schema
cannam@150 8
cannam@150 9 if [ ! -d "$schemadir" ]; then
cannam@150 10 echo "WARNING: schema directory $schemadir not found, won't be validating JSON schema" 1>&2
cannam@150 11 fi
cannam@150 12
cannam@150 13 tmpdir=$(mktemp -d)
cannam@150 14
cannam@150 15 if [ ! -d "$tmpdir" ]; then
cannam@150 16 echo "Temp directory creation failed" 1>&2
cannam@150 17 exit 1
cannam@150 18 fi
cannam@150 19
cannam@150 20 trap "rm -rf $tmpdir" 0
cannam@150 21
cannam@150 22 reqfile="$tmpdir/req.json"
cannam@150 23 respfile="$tmpdir/resp.json"
cannam@150 24 allrespfile="$tmpdir/resp.all"
cannam@150 25 input="$tmpdir/input"
cannam@150 26 expected="$tmpdir/expected"
cannam@150 27 obtained="$tmpdir/obtained"
cannam@150 28
cannam@150 29 validate() {
cannam@150 30 local file="$1"
cannam@150 31 local schemaname="$2"
cannam@150 32 if [ -d "$schemadir" ]; then
cannam@150 33 echo " * validating against schema $schemaname... " 1>&2
cannam@150 34 jsonschema -i "$file" "$schemadir/$schemaname.json" 1>&2 && \
cannam@150 35 echo " -> validated against schema $schemaname" 1>&2 || \
cannam@150 36 echo " !! failed to validate $schemaname!" 1>&2
cannam@150 37 else
cannam@150 38 echo "(schema directory $schemadir not found, skipping validation)" 1>&2
cannam@150 39 fi
cannam@150 40 }
cannam@150 41
cannam@150 42 validate_request() {
cannam@150 43 local json="$1"
cannam@150 44 echo "$json" > "$reqfile"
cannam@150 45 validate "$reqfile" "rpcrequest"
cannam@150 46 }
cannam@150 47
cannam@150 48 validate_response() {
cannam@150 49 local json="$1"
cannam@150 50 echo "$json" > "$respfile"
cannam@150 51 validate "$respfile" "rpcresponse"
cannam@150 52 }
cannam@150 53
cannam@150 54 cat > "$input" <<EOF
cannam@150 55 {"method":"list"}
cannam@150 56 {"method":"list","params": {"from":["vamp-example-plugins","something-nonexistent"]}}
cannam@150 57 {"method":"list","params": {"from":["something-nonexistent"]}}
cannam@150 58 {"method":"load","id":6,"params": {"key":"vamp-example-plugins:percussiononsets","inputSampleRate":44100,"adapterFlags":["AdaptInputDomain","AdaptBufferSize"]}}
cannam@150 59 {"method":"configure","id":"weevil","params":{"handle":1,"configuration":{"blockSize": 8, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 8}}}
cannam@150 60 {"method":"process","params": {"handle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [ [1,2,3,4,5,6,7,8] ]}}}
cannam@150 61 {"method":"finish","params": {"handle": 1}}
cannam@150 62 EOF
cannam@150 63
cannam@150 64 # Expected output, apart from the plugin list which seems a bit
cannam@150 65 # fragile to check here
cannam@150 66 cat > "$expected" <<EOF
cannam@150 67 {"id": 6, "jsonrpc": "2.0", "method": "load", "result": {"defaultConfiguration": {"blockSize": 1024, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 1024}, "handle": 1, "staticData": {"basic": {"description": "Detect percussive note onsets by identifying broadband energy rises", "identifier": "percussiononsets", "name": "Simple Percussion Onset Detector"}, "basicOutputInfo": [{"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}], "category": ["Time", "Onsets"], "copyright": "Code copyright 2006 Queen Mary, University of London, after Dan Barry et al 2005. Freely redistributable (BSD license)", "inputDomain": "TimeDomain", "key": "vamp-example-plugins:percussiononsets", "maker": "Vamp SDK Example Plugins", "maxChannelCount": 1, "minChannelCount": 1, "parameters": [{"basic": {"description": "Energy rise within a frequency bin necessary to count toward broadband total", "identifier": "threshold", "name": "Energy rise threshold"}, "defaultValue": 3, "extents": {"max": 20, "min": 0}, "unit": "dB", "valueNames": []}, {"basic": {"description": "Sensitivity of peak detector applied to broadband detection function", "identifier": "sensitivity", "name": "Sensitivity"}, "defaultValue": 40, "extents": {"max": 100, "min": 0}, "unit": "%", "valueNames": []}], "programs": [], "version": 2}}}
cannam@150 68 {"id": "weevil", "jsonrpc": "2.0", "method": "configure", "result": {"handle": 1, "outputList": [{"basic": {"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, "configured": {"binCount": 0, "binNames": [], "hasDuration": false, "sampleRate": 44100, "sampleType": "VariableSampleRate", "unit": ""}}, {"basic": {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}, "configured": {"binCount": 1, "binNames": [""], "hasDuration": false, "quantizeStep": 1, "sampleRate": 86.1328125, "sampleType": "FixedSampleRate", "unit": ""}}]}}
cannam@150 69 {"jsonrpc": "2.0", "method": "process", "result": {"features": {}, "handle": 1}}
cannam@150 70 {"jsonrpc": "2.0", "method": "finish", "result": {"features": {"detectionfunction": [{"featureValues": [0], "timestamp": {"n": 11609977, "s": 0}}]}, "handle": 1}}
cannam@150 71 EOF
cannam@150 72
cannam@150 73 # We run the whole test twice, once with the server in Capnp mode
cannam@150 74 # (converting to JSON using piper-convert) and once with it directly
cannam@150 75 # in JSON mode
cannam@150 76
cannam@150 77 #debugflag=-d
cannam@150 78 debugflag=
cannam@150 79
cannam@150 80 for format in json capnp ; do
cannam@150 81
cannam@150 82 ( export VAMP_PATH="$vampsdkdir"/examples ;
cannam@150 83 while read request ; do
cannam@150 84 validate_request "$request"
cannam@150 85 echo "$request"
cannam@150 86 done |
cannam@150 87 if [ "$format" = "json" ]; then
cannam@150 88 bin/piper-vamp-simple-server $debugflag json
cannam@150 89 else
cannam@150 90 bin/piper-convert request -i json -o capnp |
cannam@150 91 bin/piper-vamp-simple-server $debugflag capnp |
cannam@150 92 bin/piper-convert response -i capnp -o json
cannam@150 93 fi |
cannam@150 94 while read response ; do
cannam@150 95 echo "$response" >> "$allrespfile"
cannam@150 96 validate_response "$response"
cannam@150 97 done
cannam@150 98 ) < "$input"
cannam@150 99
cannam@150 100 # Skip plugin lists
cannam@150 101 tail -n +4 "$allrespfile" > "$obtained"
cannam@150 102
cannam@150 103 echo "Checking response contents against expected contents..."
cannam@150 104 if ! cmp "$obtained" "$expected"; then
cannam@150 105 diff -u1 "$obtained" "$expected"
cannam@150 106 else
cannam@150 107 echo "OK"
cannam@150 108 fi
cannam@150 109
cannam@150 110 echo "Checking plugin counts from list responses..."
cannam@150 111
cannam@150 112 # Now check the plugin lists, but as the descriptions etc are
cannam@150 113 # probably a bit fragile, let's just count the number of plugins
cannam@150 114
cannam@150 115 # First, with no "from" arg to the list call
cannam@150 116 list_no_from=$(head -n +1 "$allrespfile" | fmt -1 | grep '"key"' | wc -l)
cannam@150 117
cannam@150 118 # Now with a "from" arg that includes the library that exists
cannam@150 119 list_with_good_from=$(tail -n +2 "$allrespfile" | head -n +1 | fmt -1 |
cannam@150 120 grep '"key"' | wc -l)
cannam@150 121
cannam@150 122 # Now with a "from" arg that doesn't include any real library
cannam@150 123 list_with_bad_from=$(tail -n +3 "$allrespfile" | head -n +1 | fmt -1 |
cannam@150 124 grep '"key"' | wc -l)
cannam@150 125
cannam@150 126 if [ "$list_no_from" != "6" ]; then
cannam@150 127 echo "Wrong number of plugins from list response without \"from\" arg"
cannam@150 128 echo "Expected 6, obtained $list_no_from"
cannam@150 129 false
cannam@150 130 fi
cannam@150 131 if [ "$list_with_good_from" != "6" ]; then
cannam@150 132 echo "Wrong number of plugins from list response with good \"from\" arg"
cannam@150 133 echo "Expected 6, obtained $list_with_good_from"
cannam@150 134 false
cannam@150 135 fi
cannam@150 136 if [ "$list_with_bad_from" != "0" ]; then
cannam@150 137 echo "Wrong number of plugins from list response with bad \"from\" arg"
cannam@150 138 echo "Expected 0, obtained $list_with_bad_from"
cannam@150 139 false
cannam@150 140 fi
cannam@150 141 echo OK
cannam@150 142
cannam@150 143 rm "$allrespfile"
cannam@150 144
cannam@150 145 done
cannam@150 146
cannam@150 147 echo "Tests succeeded" # set -e at top should ensure we don't get here otherwise